DEFINT A-Z
'$INCLUDE: 'SOURCE\DIRECTQB.BI'
'$INCLUDE: 'SOURCE\DS4QB2.BI'
DECLARE FUNCTION InputBx$ (x%, y%, CNT%, C1%, c2%)
DECLARE SUB ShutdownDS4QB ()
DECLARE SUB CreateLayers (SumoNumber%, TT%)
DECLARE SUB PlaceTile (LayerFrom%, Tile%, LayerTo%, x2%, y2%, StepX%, StepY%)
DECLARE SUB DQBprintBack (Layer%, T$, x%, y%, C1%, c2%)
DIM SHARED Sc2 AS LONG

REM $DYNAMIC
SUB DQBprintBack (Layer, T$, x, y, C1, c2)
 DQBprints Layer, T$, x - 1, y - 1, C1, BOLD
 DQBprints Layer, T$, x + 1, y + 1, C1, BOLD
 DQBprints Layer, T$, x, y, c2, BOLD
END SUB

SUB FilterBox (Layer, x1%, y1%, x2%, y2%, Col%, BG, OutLine)
IF Col% OR BG% THEN
DEF SEG = DQBmapLayer(Layer)
	FOR y& = y1% TO y2%
	FOR x = x1% TO x2%
	  Offset& = y& * 320 + x
	  IF BG% THEN
	   POKE Offset&, BG%
	  ELSE
	   POKE Offset&, (((PEEK(Offset&)) MOD 16) + (Col% + 16) * 16)
	  END IF
	NEXT x
	NEXT y&
DEF SEG
END IF
IF OutLine THEN
 DQBline Layer, x1% + 1, y1%, x2%, y1%, OutLine
 DQBline Layer, x1%, y1% + 1, x1%, y2% - 1, OutLine
 DQBline Layer, x2% + 1, y1% + 1, x2% + 1, y2% - 1, OutLine
 DQBline Layer, x1% + 1, y2%, x2%, y2%, OutLine
END IF
END SUB

REM $STATIC
SUB HighScores (Scores() AS LONG, Names() AS STRING)
FOR XX2 = 319 TO DQBlen("High Scores") + 5 STEP -5
 DQBcopyLayer 8, 1
 DQBbox 1, 0, 0, XX2, 10, 4
 DQBprint 1, "High Scores", XX2 - 6 - DQBlen("High Scores"), 2, 9
 DQBprint 1, "High Scores", XX2 - 4 - DQBlen("High Scores"), 4, 9
 DQBprint 1, "High Scores", XX2 - 5 - DQBlen("High Scores"), 3, 15
 DQBcopyLayer 1, 0
 DQBwait 1
NEXT
DQBcopyLayer 1, 2
FOR YY = 1 TO 5
 FOR y = 20 TO 50 + (YY * 15) STEP 3
  DQBcopyLayer 2, 1
  Sc2 = Scores(YY)
  T$ = Names(YY) + STR$(Sc2)
  IF YY = 1 THEN C1 = 11 ELSE C1 = 15
  DQBprint 1, T$, 161 - (DQBlen(T$) / 2), y - 1, 9
  DQBprint 1, T$, 159 - (DQBlen(T$) / 2), y + 1, 9
  DQBprint 1, T$, 160 - (DQBlen(T$) / 2), y, C1
  DQBcopyLayer 1, 0
  DQBwait 1
 NEXT
 DQBcopyLayer 1, 2
NEXT
FOR XX = 0 TO 65 STEP 2
 DQBcopyLayer 2, 1
 DQBbox 1, 160 - XX, 100 - XX, 160 + XX, 100 + XX, 4
 DQBcopyLayer 1, 0
 DQBwait 1
NEXT
DO: LOOP UNTIL INKEY$ <> ""
FOR XX = 66 TO 0 STEP -3
 DQBcopyLayer 8, 2
 IF XX MOD 3 = 0 THEN XX2 = XX2 - 5
 IF XX2 < 1 THEN XX2 = 1
 DQBbox 1, 0, 0, XX2, 10, 4
 DQBbox 1, 160 - XX, 100 - XX, 160 + XX, 100 + XX, 4
 DQBbox 1, 160 - XX - 2, 100 - XX - 2, 160 + XX + 2, 100 + XX + 2, 0
 DQBcopyTransLayer 1, 2
 DQBcopyLayer 2, 0
 DQBboxf 1, 160 - XX, 100 - XX, 160 + XX, 100 + XX, 0
 DQBboxf 1, DQBlen("High Scores") + 5 - ABS(DQBlen("High Scores") + 5 - XX2), 0, DQBlen("High Scores") + 9, 10, 0
 DQBwait 1
NEXT
DQBcopyLayer 8, 2
END SUB

REM $DYNAMIC
SUB InitImageData (FileName$, ImageArray())
REM $DYNAMIC
	IF FileName$ <> "" THEN
		FileNo = FREEFILE
		OPEN FileName$ FOR BINARY AS #FileNo
		Ints = (LOF(FileNo) - 7) \ 2
		CLOSE #FileNo
		'$DYNAMIC
		REDIM ImageArray(1 TO Ints)
		DEF SEG = VARSEG(ImageArray(1))
		BLOAD FileName$, 0
		DEF SEG
	ELSE
		READ IntCount
		REDIM ImageArray(1 TO IntCount)
		FOR n = 1 TO IntCount
			READ x
			ImageArray(n) = x
		NEXT n
	END IF
END SUB

REM $STATIC
FUNCTION InputBx$ (x, y, CNT, C1, c2)
DQBsetTextBackCol 16
DQBremoveKeyboard
A! = TIMER
DO
 IF TIMER > A! + .3 THEN
  A! = TIMER: TY = 0
  IF SC = 0 THEN SC = 1: TY = -1
  IF TY = 0 AND SC = 1 THEN SC = 0
  GOSUB DrawTTT
 END IF
 I$ = INKEY$
 IF I$ <> "" THEN
  SELECT CASE I$
   CASE CHR$(8)
	IF LEN(T$) > 0 THEN
	 MID$(T$, LEN(T$), 1) = " "
	 T$ = LTRIM$(RTRIM$(T$))
	 XX = x
	 IF CNT THEN XX = 160 - (DQBlen(LTRIM$(RTRIM$(T$))) / 2)
	 DQBboxf 0, XX - 8, y, XX + DQBlen(T$) + 8, y + 6, 16
	END IF
   CASE CHR$(13): EXIT DO
   CASE ELSE: T$ = T$ + I$
  END SELECT
  GOSUB DrawTTT
 END IF
LOOP
DQBinstallKeyboard
InputBx$ = T$
DQBsetTextBackCol 0
EXIT FUNCTION
DrawTTT:
 XX = x
 IF CNT THEN XX = 160 - (DQBlen(LTRIM$(RTRIM$(T$))) / 2)
 DQBboxf 0, XX, y - 1, XX + DQBlen(T$) + 6, y + 6, 0
 DQBprint 0, T$, XX, y, c2
 IF SC THEN DQBboxf 0, XX + DQBlen(T$), y, XX + DQBlen(T$) + 4, y + 6, c2
RETURN
END FUNCTION

SUB MakeImageIndex (ImageArray(), IndexArray())
	DIM Temp(1 TO 1000)
	Ptr& = 1: IndexNo = 1: LastInt = UBOUND(ImageArray)
	DO
		Temp(IndexNo) = Ptr&
		IndexNo = IndexNo + 1
		x& = (ImageArray(Ptr&) \ 8) * (ImageArray(Ptr& + 1)) + 4
		IF x& MOD 2 THEN x& = x& + 1
		Ptr& = Ptr& + (x& \ 2)
	LOOP WHILE Ptr& < LastInt
	LastImage = IndexNo - 1
	REDIM IndexArray(1 TO LastImage)
	FOR n = 1 TO LastImage
		IndexArray(n) = Temp(n)
	NEXT n
END SUB

SUB PlaceTile (LayerFrom, Tile, LayerTo, x2, y2, StepX, StepY)
 IF Tile > 28 THEN Tile = 18
 IF Tile = 0 THEN Tile = 18
 IF Tile > 198 THEN Tile = Tile - 198: LayerFrom = LayerFrom + 1
 IF Tile > 198 THEN Tile = Tile - 198: LayerFrom = LayerFrom + 1
 x = ((Tile MOD (319 \ StepX)) * StepX) - StepX
 y = (INT((Tile \ (319 \ StepX))) * StepX)
 IF Tile MOD (319 \ StepX) = 0 THEN x = (319 \ StepX) * StepX - StepX: y = y - (StepY)
 DQBxPut LayerFrom, x, y, x + StepX - 1, y + StepY - 1, LayerTo, x2, y2
END SUB

SUB Qgame
 dummy& = SETMEM(17000)
 RemoveMusic 1
 ShutdownDS4QB
 DQBfadeTo 0, 0, 0: DQBclose: END
END SUB

SUB SumoEX (File$, Pal AS STRING)
 DIM Pic(32001) AS INTEGER
 DQBcopyLayer 0, 2
 IF DQBloadImage(5, 0, 0, File$, Pal, 319, 199) THEN PRINT DQBerror$
 DQBget 5, 0, 0, 319, 199, VARSEG(Pic(0)), VARPTR(Pic(0))
 FOR XX = 319 TO 0 STEP -8
  DQBcopyLayer 2, 1
  DQBput 1, XX, 0, VARSEG(Pic(0)), VARPTR(Pic(0))
  DQBcopyLayer 1, 0
  DQBwait 1
 NEXT
 ERASE Pic
END SUB

SUB TBox (L, x1, y1, x2, y2, C, DB, Pal AS STRING)
DEF SEG = DQBmapLayer(L)
 FOR XX = x1 TO x2
 FOR YY = y1 TO y2
  P = PEEK(YY * 320& + XX)
  CC = P
  IF C THEN CC = (((P) MOD 16) + (C + 16) * 16)
  IF DB THEN
   CALL DQBgetCol(CC, R, G, B)
   R = R + DB: G = G + DB: B = B + DB
   CC = DQBfindPalCol(Pal, R, G, B)
  END IF
  POKE YY * 320& + XX, CC
 NEXT
 NEXT
DEF SEG
END SUB

SUB Unleashed (Tile, Text$, Pal AS STRING)
IF DQBloadImage(1, 0, 0, "DATA\UNLEASH.PCX", Pal, 319, 199) THEN BEEP
DQBcopyLayer 8, 2: DQBcopyTransLayer 1, 2
Tile = Tile + 1
CALL CreateLayers(-1, Tile)
n = 90 ': DQBplaySound 3, 2, 22050, 0
FOR A = 1 TO 360 STEP 6
 IF n > 2 THEN n = n - 2
 DQBcopyLayer 2, 1
 PlaceTile 6, Tile, 1, 137 + (n * SIN(A)), 77 + (n * COS(A)), 51, 51
 PlaceTile 6, Tile, 1, 137 + (n * SIN(A)), 77 + (n * SIN(A)), 51, 51
 PlaceTile 6, Tile, 1, 137 + (n * COS(A)), 77 + (n * COS(A)), 51, 51
 PlaceTile 3, 1, 1, 152, 137, 17, 17
 XX = 160 - (4 + (DQBlen(Text$) / 2))
 DQBprintBack 1, Text$, XX, 64, 9, 15
 DQBwait 1
 DQBcopyLayer 1, 0
NEXT
TTT = Tile
Tile = 1
XX = 160 - (4 + (DQBlen(Text$) / 2))
DQBremoveKeyboard
DO
 I$ = INKEY$
 IF I$ <> "" THEN EXIT DO
 DQBboxf 1, 137, 77, 137 + 48, 77 + 48, 0
 DQBcopyTransLayer 2, 1
 DQBprintBack 1, Text$, XX, 64, 9, 15
 WWait = WWait + 1
 IF WWait = 6 THEN Frame = Frame + 1: WWait = 0
 IF Frame = 3 THEN
  Frame = 0
  Tile = INT(RND * 7) + 1
  IF Tile = 1 THEN Tile = 1
  IF Tile = 2 THEN Tile = 4
  IF Tile = 3 THEN Tile = 7
  IF Tile = 4 THEN Tile = 10
  IF Tile = 5 THEN Tile = 13
  IF Tile = 6 THEN Tile = 16
  IF Tile = 7 THEN Tile = 19
  IF Tile = 8 THEN Tile = 21
 END IF
 DQBboxf 1, 152, 137, 152 + 16, 137 + 16, 0
 PlaceTile 3, Tile + Frame, 1, 152, 137, 17, 17
 PlaceTile 6, TTT, 1, 137 + (n * COS(A)), 77 + (n * COS(A)), 51, 51
 DQBcopyLayer 1, 0
 DQBwait 1
LOOP
DQBfadeTo 63, 63, 63
DQBinstallKeyboard
END SUB

