'$DYNAMIC
DEFINT A-Z
DECLARE FUNCTION InputBx$ (x%, Y%, CNT%, C1%, c2%)
DECLARE SUB MakeRanks ()
DECLARE SUB ShowWinner ()
DECLARE SUB Rankings ()
DECLARE SUB LoadRand ()
DECLARE SUB Tournament ()
DECLARE SUB SetAttrib (Su%)
DECLARE SUB Standings ()
DECLARE SUB SelectSumo (Player%)
DECLARE SUB SumoDie ()
DECLARE SUB CreateLayers (SumoNumber%, TT%)
DECLARE SUB HandleSumo (S%)
DECLARE SUB DrawSumo (S%, Layer%)
DECLARE SUB DrawScreen (Layer%)
DECLARE FUNCTION CheckCollide% (S%, x%, Y%)
DECLARE SUB DoKeys (S%, C%)
DECLARE SUB Gui (Ext$)
DECLARE SUB CreateSumo (S%)
DECLARE SUB InitSumo ()
DECLARE SUB Qgame ()
DECLARE SUB TBox (L%, x1%, y1%, x2%, y2%, C%, DB%, Pal AS STRING)
DECLARE SUB Unleashed (Tile%, Text$, Pal AS STRING)
DECLARE SUB HighScores (Scores() AS LONG, Names() AS STRING)
DECLARE SUB SumoEX (File$, Pal AS STRING)
DECLARE SUB InitImageData (filename$, ImageArray%())
DECLARE SUB MakeImageIndex (ImageArray%(), IndexArray%())
DECLARE SUB PlaceTile (LayerFrom%, Tile%, LayerTo%, x2%, y2%, StepX%, StepY%)
DECLARE SUB DQBprintBack (Layer%, T$, x%, Y%, C1%, c2%)
DECLARE SUB FilterBox (Layer%, x1%, y1%, x2%, y2%, Col%, BG%, OutLine%)
TYPE Sumo
 x               AS INTEGER
 Y               AS INTEGER
 x2              AS INTEGER
 y2              AS INTEGER
 Frame           AS INTEGER
 AnimCount       AS INTEGER
 Direction       AS INTEGER
 Action          AS INTEGER
 ActionCount     AS INTEGER
 Special         AS INTEGER
 SpecialBlocks   AS INTEGER
 SpecialCount    AS INTEGER
 Stamina         AS INTEGER
 StaminaCount    AS INTEGER
 Strength        AS INTEGER
 speed           AS INTEGER
 Weight          AS INTEGER
 Rage            AS INTEGER
 Col             AS INTEGER
 Confused        AS INTEGER
 CurrentSpeed    AS INTEGER
 CurrentStrength AS INTEGER
 SpeedPowerUp    AS INTEGER
 StrengthPowerUp AS INTEGER
 pname           AS STRING * 25
 OffX            AS INTEGER
 offY            AS INTEGER
 StepOff         AS INTEGER
 HitWPower       AS INTEGER
 Shock           AS INTEGER
 CommonDir       AS INTEGER
 Move1           AS INTEGER
 Move2           AS INTEGER
 SpecialMove     AS INTEGER
 Rank            AS INTEGER
 TileSet         AS INTEGER
 SpecialBlink    AS INTEGER
END TYPE
TYPE Referee
 x AS INTEGER
 Y AS INTEGER
END TYPE
TYPE Game
 Time     AS INTEGER
 Mode     AS INTEGER
 Players  AS INTEGER
 Winner   AS INTEGER
 FadeUp   AS INTEGER
 FadeDown AS INTEGER
 PowerUp  AS INTEGER
 SoundOn  AS INTEGER
 TimeLeft AS INTEGER
 Diff     AS INTEGER
END TYPE
TYPE Place
 Strength AS INTEGER
 speed AS INTEGER
 Col AS INTEGER
 Weight AS INTEGER
 Rage AS INTEGER
 pname AS STRING * 15
 TileSet AS INTEGER
END TYPE
TYPE Blood
 x AS INTEGER
 Y AS INTEGER
 Xoff AS INTEGER
 Yoff AS INTEGER
 XX AS INTEGER
END TYPE
TYPE Registers
         AX    AS INTEGER
         BX    AS INTEGER
         CX    AS INTEGER
         DX    AS INTEGER
         BP    AS INTEGER
         SI    AS INTEGER
         DI    AS INTEGER
         FLAGS AS INTEGER
         DS    AS INTEGER
         ES    AS INTEGER
END TYPE
COMMON SHARED QMIDIRegs AS Registers, MEM.SEGMENT() AS INTEGER
COMMON SHARED MIDI.PLAYTIME AS SINGLE, MIDI.ERROR AS INTEGER, PAUSED AS SINGLE
COMMON SHARED SBMIDI.INTERRUPT AS INTEGER, MEM.ALLOCATED() AS LONG
COMMON SHARED SBSIM.INTERRUPT AS INTEGER, MIXER.CHIP AS INTEGER
COMMON SHARED SB.BASEPORT AS INTEGER, SB.IRQ AS INTEGER
COMMON SHARED SB.LODMA AS INTEGER, SB.HIDMA AS INTEGER, SB.CARDTYPE AS INTEGER
COMMON SHARED SB.MPU401 AS INTEGER, BIT.STORAGE() AS INTEGER
COMMON SHARED SENSITIVE AS INTEGER, REVERSE.STEREO AS INTEGER
COMMON SHARED SOUND.DISABLED AS INTEGER, CURRENTHANDLE AS INTEGER


